/* Error codes for MQSeries Services
 *
 * Copyright (C) IBM Corporation 1995, 1999
 */

#ifndef mqsserr
#define mqsserr

#include <cmqc.h>

#define EMQM_REPLY_QUEUE_NOT_AUTH         (MQFB_APPL_FIRST)
#define EMQM_UNKNOWN_QUEUE_MGR            (MQFB_APPL_FIRST + 1)
#define EMQM_DQH_STRUC_LEN_ERR1           (MQFB_APPL_FIRST + 2)
#define EMQM_DQH_STRUC_LEN_ERR2           (MQFB_APPL_FIRST + 3)
#define EMQM_UNKNOWN_REPLYTO_QMGR         (MQFB_APPL_FIRST + 4)
#define EMQM_NOT_AUTH_BY_PAYMENT_OPTION   (MQFB_APPL_FIRST + 5)
#define EMQM_MQXM_LENGTH_INCORRECT        (MQFB_APPL_FIRST + 6)
#define EMQM_MQXM_TOTAL_LENGTH_INCORRECT  (MQFB_APPL_FIRST + 7)
#define EMQM_RECEIVING_QMGR_EXPIRED       (MQFB_APPL_FIRST + 8)

#define EMQM_NO_IE_ALIAS                  (MQFB_APPL_FIRST + 9)
#define EMQM_IE_NON_PAYMENT               (MQFB_APPL_FIRST + 10)
#define EMQM_UNKNOWN_IE_RECIP             (MQFB_APPL_FIRST + 11)
#define EMQM_ESO_MISMATCH                 (MQFB_APPL_FIRST + 12)

#define EMQM_MISSING_CTACCT 		         (MQFB_APPL_FIRST + 13)
#define EMQM_MISSING_ORGACCT 		         (MQFB_APPL_FIRST + 14)
#define EMQM_MISSING_CHROPT 		         (MQFB_APPL_FIRST + 15)
#define EMQM_MISSING_PAYOPT 		         (MQFB_APPL_FIRST + 16)

/* feedback code ranges: */

#define MQSSFB_VALIDATE_MESSAGE_BASE 	   (MQFB_APPL_FIRST + 20)
#define MQSSFB_DEST_BASE 		            MQSSFB_VALIDATE_MESSAGE_BASE
#define MQSSFB_REPLY_BASE 		            (MQSSFB_VALIDATE_MESSAGE_BASE + 8)
#define MQSSFB_MISC_BASE 		            (MQSSFB_VALIDATE_MESSAGE_BASE + 16)
#define MQSSFB_SENDING_BASE 		         (MQSSFB_MISC_BASE + 20)

#define MQSSFB_QMGR_UNKNOWN 		         1
#define MQSSFB_QMGR_EXPIRED 		         2
#define MQSSFB_QMGR_CONFIG 		         3
#define MQSSFB_Q_REQUIRED 		            4
#define MQSSFB_Q_NOT_AUTH 		            5
#define MQSSFB_Q_CONFIG 		            7

/* feedback codes returned by validate_sender: */

#define MQSSFB_CHANNEL_NOT_AUTH 	         MQSSFB_SENDING_BASE
#define MQSSFB_SENDING_QMGR_UNKNOWN  	   (MQSSFB_SENDING_BASE + MQSSFB_QMGR_UNKNOWN)
#define MQSSFB_SENDING_QMGR_EXPIRED  	   (MQSSFB_SENDING_BASE + MQSSFB_QMGR_EXPIRED)
#define MQSSFB_SENDING_QMGR_CONFIG   	   (MQSSFB_SENDING_BASE + MQSSFB_QMGR_CONFIG)

/* feedback codes returned by validate_message: */

#define MQSSFB_DEST_QMGR_UNKNOWN  	      (MQSSFB_DEST_BASE + MQSSFB_QMGR_UNKNOWN)
#define MQSSFB_DEST_QMGR_EXPIRED  	      (MQSSFB_DEST_BASE + MQSSFB_QMGR_EXPIRED)
#define MQSSFB_DEST_QMGR_CONFIG   	      (MQSSFB_DEST_BASE + MQSSFB_QMGR_CONFIG)
#define MQSSFB_DEST_Q_NOT_AUTH    	      (MQSSFB_DEST_BASE + MQSSFB_Q_NOT_AUTH)
#define MQSSFB_DEST_Q_CONFIG	  	         (MQSSFB_DEST_BASE + MQSSFB_Q_CONFIG)

#define MQSSFB_REPLY_QMGR_UNKNOWN 	      (MQSSFB_REPLY_BASE + MQSSFB_QMGR_UNKNOWN)
#define MQSSFB_REPLY_QMGR_EXPIRED 	      (MQSSFB_REPLY_BASE + MQSSFB_QMGR_EXPIRED)
#define MQSSFB_REPLY_QMGR_CONFIG  	      (MQSSFB_REPLY_BASE + MQSSFB_QMGR_CONFIG)
#define MQSSFB_REPLY_Q_REQUIRED   	      (MQSSFB_REPLY_BASE + MQSSFB_Q_REQUIRED)
#define MQSSFB_REPLY_Q_NOT_AUTH   	      (MQSSFB_REPLY_BASE + MQSSFB_Q_NOT_AUTH)
#define MQSSFB_REPLY_Q_CONFIG	  	         (MQSSFB_REPLY_BASE + MQSSFB_Q_CONFIG)

#define MQSSFB_IE_NO_ALIAS 		         MQSSFB_MISC_BASE
#define MQSSFB_IE_REPLY_QMGR_CONFLICT 	   (MQSSFB_MISC_BASE + 1)
#define MQSSFB_IE_DEST_OPT_CONFLICT 	   (MQSSFB_MISC_BASE + 2)
#define MQSSFB_NOT_AUTH_BY_PAY_OPT 	      (MQSSFB_MISC_BASE + 3)
#define MQSSFB_SYSTEM_ERROR 		         (MQSSFB_MISC_BASE + 4)
#define MQSSFB_NO_SUCH_ALIAS 		         (MQSSFB_MISC_BASE + 5)
#define MQSSFB_INVALID_MQXQH 		         (MQSSFB_MISC_BASE + 6)

#define EMQM_VALID 			               0
#define EMQM_CHANNEL_NOT_AUTH 		      1
#define EMQM_NO_QUEUE 			            2
#define EMQM_REPLY_TO_QUEUE_REQUIRED 	   3
#define EMQM_NOT_AUTH 			            4
#define EMQM_RTQ_NOT_AUTH 		            5
#define EMQM_CHANNEL_NOT_KNOWN 		      6
#define EMQM_SYSTEM_ERROR 		            7
#define EMQM_UNKNOWN_QUEUE_MANAGER 	      8
#define EMQM_PARSE_ERROR 		            9
#define EMQM_EXIT_MALLOC_FAIL 		      10
#define EMQM_CLOSE_CHANNEL 		         11
#define EMQM_UNKNOWN_REPLY 		         12
#define EMQM_UNKNOWN_DEST 		            13
#define EMQM_MSG_TOO_BIG 		            14
#define EMQM_NO_CUST_DLQ 		            15
#define EMQM_PCF_FAIL 			            16

#endif
