/*@unused@*/static char *sccsid = "deadq.c,  Version 1 Release 6 20/08/2001";
#define TITLE "MQSeries Deadletter Queue Monitor"
/******************************************************************/
/*                                                                */
/* Program name: deadq                                            */
/*                                                                */
/* Description: MQseries Dealtter Queue Monitor                   */
/*              inlcuding MQSeries Services dlq messages          */
/*                                                                */
/******************************************************************/
/*                                                                */
/*                                                                */
/* Version 1.1, 29/09/1999, First release                         */
/* Version 1.2, 14/02/2000, Clean up                              */
/* Version 1.3, 22/02/2000, Read default profile and              */
/*                          inquire qmgr for dlq name             */
/* Version 1.4, 03/03/2000, Profile is optional                   */
/* Version 1.5, 03/11/2000, Cleanup for SupportPac release        */
/* Version 1.6, 20/08/2001, Checked with LCLint                   */
/*                                                                */
/******************************************************************/
#include <stdio.h>                    /* ANSI                     */
#include <stdlib.h>                   /* ANSI                     */
#include <string.h>                   /* ANSI                     */
#include <time.h>
/* MQSeries product include file                                  */
#include <cmqc.h>
#include <cmqcfc.h>
/* Windows NT specific include file                               */
#include <windows.h>
/* Utils include files                                            */
#include "../../src/file_util.h"      /* file functions           */
#include "../../src/mq_util.h"        /* MQSeries functions       */
/* MQSeries Services include files                                */
#include "../../MQSeriesServices/src/mqss.h"
/* Program specific include files                                 */
#include "deadq.h"
#include "profile.h"

HINSTANCE hInst;

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
   char ProfileName[PATH_MAX];
   char LogText[255];
   PINITFILE InitFile    = NULL;
   /***************************************************************/
   /* variables for MQCONN                                        */
   MQHCONN  Hconn = MQHC_UNUSABLE_HCONN;/* connection handle      */
   /***************************************************************/
   /* variables for MQOPEN                                        */
   MQOD    ObjDesc     = { MQOD_DEFAULT }; /* Object Descriptor   */
   MQOD    ObjDescInq  = { MQOD_DEFAULT }; /* Object Descriptor   */
   MQLONG  OpenOptions = 0;
   MQHOBJ  Hobj        = 0;                /* Object handle       */
   /***************************************************************/
   /* variables for MQGET                                         */
   MQMD    MsgDesc = { MQMD_DEFAULT };   /* Message Descriptor    */
   PMQMD   pmdin ;
   MQGMO   GetMsgOpts = { MQGMO_DEFAULT };/* get message options  */
   PMQGMO  pgmoin;
   PMQBYTE Buffer       = NULL;
   MQLONG  BufferLength = BUFFERLENGTH;
   MQLONG  DataLength   = 0;
   MQLONG  CompCode = MQCC_UNKNOWN; /* completion code            */
   MQLONG  Reason = -1;             /* reason code                */
   MQLONG  selectcnt    =  1;       /* Count of inquire selectors */
   MQLONG  selectors[1];            /* Array of attr selectors    */
   MQLONG  intattrcnt   =  0;       /* Count of integer attrs     */
   MQLONG  intattr[1];              /* Array of integer attrs     */
   /***************************************************************/
   /* Use a version 2 MQMD incase the message is Segmented/Grouped*/
   MsgDesc.Version = MQMD_VERSION_2 ;
   /***************************************************************/
   /* Initialise storage ....                                     */
   if ((pmdin = malloc(sizeof(MQMD))) == NULL )
		exit(EXIT_FAILURE);																		/* 20/08/2001 */
   if ((pgmoin = malloc(sizeof(MQGMO))) == NULL )
		exit(EXIT_FAILURE);																		/* 20/08/2001 */
   if ((Buffer = malloc(BUFFERLENGTH)) == NULL )
		exit(EXIT_FAILURE);																		/* 20/08/2001 */

   if ( strlen((char *)lpCmdLine) == 0 )
	  InitFile = DefaultInit();
   else {
      strncpy(ProfileName, (char *)lpCmdLine, PATH_MAX);

#ifdef DEBUG
      DisplayMessage(ProfileName, MB_INFORMATION);
#endif

      if ( (InitFile = ReadProfile(ProfileName)) == NULL ) {
         sprintf(LogText, "Error reading profile : %s", ProfileName);
         DisplayMessage(LogText, MB_ERROR);
         exit(EXIT_FAILURE);																	/* 20/08/2001 */
      } /* if ( (InitFile = ReadProfile(ProfileName)) == NULL ) */

   } /* if ( strlen((char *)lpCmdLine) == 0 ) */

   (void)LogInitFile(InitFile, TITLE);														/* 20/08/2001 */
	/* Return value (type int) ignored */

   MQCONN(InitFile->qmgr, &Hconn, &CompCode, &Reason);
   (void)WriteLogMQ(InitFile->logdir, _MQCONN, CompCode, Reason);					/* 20/08/2001 */
	/* Return value (type int) ignored */

   if (CompCode == MQCC_FAILED) {
      sprintf(LogText, "MQCONN FAILED\n%s", ReasonString(Reason));
      DisplayMessage(LogText, MB_ERROR);

		free(InitFile);
		free(pmdin);
		free(pgmoin);
		free(Buffer);

      return((int)Reason);
   } /* if (CompCode == MQCC_FAILED) */

   if (*InitFile->deadq == '\0') {
	   /*                                                                */
      /* Open the queue manager for inquire                             */
      /*                                                                */
      ObjDescInq.ObjectType = MQOT_Q_MGR;

      strcpy(ObjDescInq.ObjectQMgrName,InitFile->qmgr);

      OpenOptions  = MQOO_INQUIRE;
	   OpenOptions += MQOO_FAIL_IF_QUIESCING;

      MQOPEN(Hconn, &ObjDescInq, OpenOptions, &Hobj, &CompCode, &Reason);
      (void)WriteLogMQ(InitFile->logdir, _MQOPEN, CompCode, Reason);				/* 20/08/2001 */
		/* Return value (type int) ignored */

      if (CompCode == MQCC_FAILED) {
         sprintf(LogText, "MQOPEN FAILED\n%s", ReasonString(Reason));
         DisplayMessage(LogText, MB_ERROR);

         MQDISC(&Hconn, &CompCode, &Reason);
         (void)WriteLogMQ(InitFile->logdir, _MQDISC, CompCode, Reason);
			/* Return value (type int) ignored */

			free(InitFile);																		/* 20/08/2001 */
			free(pmdin);																			/* 20/08/2001 */
			free(pgmoin);																			/* 20/08/2001 */
			free(Buffer);																			/* 20/08/2001 */

         return((int)Reason);
      } /* if (CompCode == MQCC_FAILED) */

      /*                                                                */
      /* Find out the name of the deadletter queue name                 */
      /*                                                                */
      selectors[0] = MQCA_DEAD_LETTER_Q_NAME;

      MQINQ(Hconn, Hobj, selectcnt, selectors, intattrcnt, intattr, (MQLONG)sizeof(ObjDesc.ObjectName), InitFile->deadq, &CompCode, &Reason);
      (void)WriteLogMQ(InitFile->logdir, _MQINQ, CompCode, Reason);				/* 20/08/2001 */
		/* Return value (type int) ignored */

      if(CompCode == MQCC_FAILED) {
	      sprintf(LogText, "MQINQ FAILED\n%s", ReasonString(Reason));
         DisplayMessage(LogText, MB_ERROR);

         MQCLOSE(Hconn, &Hobj, MQCO_NONE, &CompCode, &Reason);
	      (void)WriteLogMQ(InitFile->logdir, _MQCLOSE, CompCode, Reason);
			/* Return value (type int) ignored */

         MQDISC(&Hconn, &CompCode, &Reason);
         (void)WriteLogMQ(InitFile->logdir, _MQDISC, CompCode, Reason);
			/* Return value (type int) ignored */

			free(InitFile);																		/* 20/08/2001 */
			free(pmdin);																			/* 20/08/2001 */
			free(pgmoin);																			/* 20/08/2001 */
			free(Buffer);																			/* 20/08/2001 */

         return((int)Reason);
      } /* if(CompCode == MQCC_FAILED) */

      MQCLOSE(Hconn, &Hobj, MQCO_NONE, &CompCode, &Reason);
      (void)WriteLogMQ(InitFile->logdir, _MQCLOSE, CompCode, Reason);			/* 20/08/2001 */
		/* Return value (type int) ignored */

      sprintf(LogText, "deadq = %.48s", InitFile->deadq );
      (void)WriteLogFile(InitFile->logdir, LOG, LogText);							/* 20/08/2001 */
		/* Return value (type int) ignored */

   } /* if (*InitFile->deadq == '\0') */

   /*                                                                */
   /* Set the options for the open call                              */
   /*                                                                */
   OpenOptions = MQOO_BROWSE;

   strncpy(ObjDesc.ObjectName, InitFile->deadq, (size_t)MQ_Q_NAME_LENGTH);		/* 20/08/2001 */

   MQOPEN(Hconn, &ObjDesc, OpenOptions, &Hobj, &CompCode, &Reason );
   (void)WriteLogMQ(InitFile->logdir, _MQOPEN, CompCode, Reason);					/* 20/08/2001 */
	/* Return value (type int) ignored */

   if (CompCode == MQCC_FAILED) {
      sprintf(LogText, "MQOPEN DLQ FAILED\n%s", ReasonString(Reason));
      DisplayMessage(LogText, MB_ERROR);

	   MQDISC(&Hconn, &CompCode, &Reason);
      (void)WriteLogMQ(InitFile->logdir, _MQDISC, CompCode, Reason);				/* 20/08/2001 */
		/* Return value (type int) ignored */

		free(InitFile);																			/* 20/08/2001 */
		free(pmdin);																				/* 20/08/2001 */
		free(pgmoin);																				/* 20/08/2001 */
		free(Buffer);																				/* 20/08/2001 */
	  
      return((int)Reason);
   } /* if (CompCode == MQCC_FAILED) */

   /*                                                               */
   /* Set the version number fot the Get Message Options            */
   GetMsgOpts.Version = MQGMO_VERSION_2;

   /* Avoid need to reset Message ID and Correlation ID after       */
   /* every MQGET                                                   */
   GetMsgOpts.MatchOptions = MQMO_NONE;

   /* Set the options for the get calls                             */
   GetMsgOpts.Options  = MQGMO_WAIT;
   GetMsgOpts.Options += MQGMO_BROWSE_NEXT ;
   GetMsgOpts.Options += MQGMO_ACCEPT_TRUNCATED_MSG;
   GetMsgOpts.Options += MQGMO_CONVERT;

   GetMsgOpts.WaitInterval = MQWI_UNLIMITED;

   /* Set the message desctriptor and get message                   */
   /* options to the defaults                                       */
   /*                                                               */
   pmdin  = memcpy(pmdin, &MsgDesc, sizeof(MQMD) );
   pgmoin = memcpy(pgmoin, &GetMsgOpts, sizeof(MQGMO) );

   /*                                                               */
   /* Loop until MQGET unsuccessful                                 */
   /*                                                               */
   while(CompCode != MQCC_FAILED) {
            
      /* Initialize the buffer to blanks                            */
      memset(Buffer,(char)' ',BUFFERLENGTH);												/* 20/08/2001 */

	   pmdin->CodedCharSetId = MQCCSI_Q_MGR;
      
      MQGET(Hconn, Hobj, pmdin, pgmoin, BufferLength, Buffer, &DataLength, &CompCode, &Reason);
      (void)WriteLogMQ(InitFile->logdir, _MQGET, CompCode, Reason);				/* 20/08/2001 */
		/* Return value (type int) ignored */

      if (Reason != MQRC_NONE && Reason != MQRC_TRUNCATED_MSG_ACCEPTED) {
            /**/
      }
      else {

         sprintf( LogText, "DestQMgrName %.48s\nDestQName %.48s\nPutApplName %.28s\nPutDate %.8s\nPutTime %.8s\nReason %s",
                  ((MQDLH *)(Buffer))->DestQMgrName,
		            ((MQDLH *)(Buffer))->DestQName,
				      pmdin->PutApplName,
				      ((MQDLH *)(Buffer))->PutDate,
				      ((MQDLH *)(Buffer))->PutTime,
				      pReasonString( (MQLONG) ((MQDLH *)(Buffer))->Reason)  );

      	DisplayMessage(LogText, MB_INFORMATION);

      } /* if (Reason != MQRC_NONE && Reason != MQRC_TRUNCATED_MSG_ACCEPTED) */

   } /* while(CompCode != MQCC_FAILED) */

   
   MQCLOSE(Hconn, &Hobj, MQCO_NONE, &CompCode, &Reason);
   (void)WriteLogMQ(InitFile->logdir, _MQCLOSE, CompCode, Reason);				/* 20/08/2001 */
	/* Return value (type int) ignored */

   MQDISC(&Hconn, &CompCode, &Reason);
   (void)WriteLogMQ(InitFile->logdir, _MQDISC, CompCode, Reason);					/* 20/08/2001 */
	/* Return value (type int) ignored */

	free(InitFile);																				/* 20/08/2001 */
	free(pmdin);																					/* 20/08/2001 */
	free(pgmoin);																					/* 20/08/2001 */
	free(Buffer);																					/* 20/08/2001 */

   return((int)Reason);
}


VOID DisplayMessage(char *str, char MB)
{
   MessageBox(NULL, str, TITLE, MB);
}


char *pReasonString(MQLONG Reason)
{
	if (Reason < MQFB_APPL_FIRST )
		return(ReasonString(Reason));
	else
	   return(MQSSReasonString(Reason));

	return("UNKNOWN Reason Code");
}
