#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* Utils include files                                            */
#include "../../src/defs.h"           /* general include file     */
#include "../../src/file_util.h"      /* file functions           */
#include "../../src/mq_util.h"        /* MQSeries functions       */
/* Functions specific include file                                */
#include "profile.h"

extern int MQLogLevel;

PINITFILE ReadProfile(char *FileName)
{
   FILE *fp = NULL;
   char buffer[256];
   PINITFILE InitFile = NULL;

   if ( (fp = fopen(FileName, "r")) == NULL ) {
      fprintf(stderr, "Cannot open profile : %s!\n", FileName);
      return(NULL);
   }

   if ( (InitFile = malloc(sizeof(INITFILE))) == NULL) {
      fprintf(stderr, "Cannot allocate memory !\n");
      return(NULL);
   }

   *(InitFile->qmgr)   = '\0';
   *(InitFile->logdir) = '\0';
   *(InitFile->deadq)  = '\0';
	InitFile->loglevel  = MQLogLevel;
   

   while ( fgets(buffer, sizeof(buffer) - 1, fp) ) {
      buffer[strlen(buffer) - 1] = '\0';

      if ( strncmp(buffer, "logdir=", 7) == 0 ) {
         strcpy(InitFile->logdir, buffer + 7);
         CheckPath(InitFile->logdir);
      }
      else if ( strncmp(buffer, "qmgr=", 5) == 0 )
         strcpy(InitFile->qmgr, buffer + 5);
      else if ( strncmp(buffer, "deadq=", 6) == 0 )
         strcpy(InitFile->deadq, buffer + 6);
	   else if ( strncmp(buffer, "loglevel=", 9) == 0 ) {
         InitFile->loglevel = atoi(buffer + 9);
		 MQLogLevel = InitFile->loglevel;
	   }
   } /* while ( fgets(buffer, sizeof(buffer) - 1, fp) ) */

   MQLogLevel = InitFile->loglevel;

   if (fclose(fp) == EOF) {
     fprintf(stderr, "Cannot close profile : %s!\n", FileName);
     return(NULL);
  }

  return(InitFile);
}


int LogInitFile(PINITFILE InitFile, char *Title)
{
   int rc = 0;
   char LogText[255];

   sprintf(LogText,  "Start %s for %.48s" 
	                  "\n\t\t\tdeadq = %.48s" 
					      "\n\t\t\tloglevel = %d", 
                     Title,
		               ( (*(InitFile->qmgr) == '\0')  ? "<default>" : InitFile->qmgr),
	                  ( (*(InitFile->deadq) == '\0') ? "<inquire>" : InitFile->deadq),
		               (int)InitFile->loglevel );
      
   rc = WriteLogFile(InitFile->logdir, LOG, LogText);

   return(rc);
}


PINITFILE DefaultInit(void)
{
   PINITFILE InitFile = NULL;

   if ( (InitFile = malloc(sizeof(INITFILE))) == NULL) {
      fprintf(stderr, "Cannot allocate memory !\n");
      return(NULL);
   }

   *(InitFile->qmgr)   = '\0';
   *(InitFile->logdir) = '\0';
   *(InitFile->deadq)  = '\0';
	InitFile->loglevel  = MQLogLevel = 2;
   
   return InitFile;
}